3 # zgrep -- a wrapper around a grep program that decompresses files as needed
4 # Adapted from a version sent by Charles Levert <charles@comm.polymtl.ca>
6 # Copyright (C) 1998, 2001, 2002, 2006, 2007, 2009 Free Software Foundation
7 # Copyright (C) 1993 Jean-loup Gailly
9 # This program is free software; you can redistribute it and/or modify
10 # it under the terms of the GNU General Public License as published by
11 # the Free Software Foundation; either version 3 of the License, or
12 # (at your option) any later version.
14 # This program is distributed in the hope that it will be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
17 # GNU General Public License for more details.
19 # You should have received a copy of the GNU General Public License along
20 # with this program; if not, write to the Free Software Foundation, Inc.,
21 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
25 --__bindir) bindir
=${2?}; shift; shift;;
31 version
='zgrep (gzip) @VERSION@
32 Copyright (C) 2007, 2009-2010 Free Software Foundation, Inc.
33 This is free software. You may redistribute copies of it under the terms of
34 the GNU General Public License <http://www.gnu.org/licenses/gpl.html>.
35 There is NO WARRANTY, to the extent permitted by law.
37 Written by Jean-loup Gailly.'
39 usage
="Usage: $0 [OPTION]... [-e] PATTERN [FILE]...
40 Look for instances of PATTERN in the input FILEs, using their
41 uncompressed contents if they are compressed.
43 OPTIONs are the same as for 'grep'.
45 Report bugs to <bug-gzip@gnu.org>."
47 # sed script to escape all ' for the shell, and then (to handle trailing
48 # newlines correctly) turn trailing X on last line into '.
50 s/'\''/'\''\\'\'''\''/g
57 files_without_matches
=0
61 while test $# -ne 0; do
67 (-[0123456789abcdhHiIKLlnoqrRsTuUvVwxyzZ
]?
*)
68 arg2
=-\'$
(expr "X${option}X" : 'X-.[0-9]*\(.*\)' |
sed "$escape")
69 eval "set -- $arg2 "'${1+"$@"}'
70 option
=$
(expr "X$option" : 'X\(-.[0-9]*\)');;
71 (--binary-*=* |
--[lm
]a
*=* |
--reg*=*)
73 (-[ABCDefm
] |
--binary-* |
--file |
--[lm
]a
* |
--reg*)
74 case ${1?"$option option requires an argument"} in
76 optarg
=" '"$
(printf '%sX\n' "$1" |
sed "$escape");;
88 operands
="$operands '"$
(printf '%sX\n' "$option" |
sed "$escape");;
90 operands
="$operands '$option'";;
92 ${POSIXLY_CORRECT+break}
97 (-[drRzZ
] |
--di* |
--exc* |
--inc* |
--rec* |
--nu*)
98 printf >&2 '%s: %s: option not supported\n' "$0" "$option"
100 (-[ef
]* |
--file |
--file=* |
--reg*)
101 # The pattern is coming from a file rather than the command-line.
102 # If the file is actually stdin then we need to do a little
103 # magic, (since we use stdin to pass the gzip output to grep).
104 # So find a free fd and change the argument to then use this
105 # file descriptor for the pattern.
107 (" '-'" |
" '/dev/stdin'" |
" '/dev/fd/0'")
109 eval 'test -e .' 2>/dev
/null \
110 && eval 'exists(){ test -e "$@"; }' \
111 ||
eval 'exists(){ test -r "$@" || test -w "$@"; }'
112 # Start search from 6 since the script already uses 3 and 5
116 if ! exists
/proc
/$$
/fd
/$fd; then
121 if test $fd = 255; then
122 printf >&2 '%s: no free file descriptor\n' "$0"
126 optarg
=/dev
/fd
/$pat_fd;
129 (--h |
--he |
--hel |
--help)
130 echo "$usage" ||
exit 2
132 (-H |
--wi |
--wit |
--with |
--with- |
--with-f |
--with-fi \
133 |
--with-fil |
--with-file |
--with-filen |
--with-filena |
--with-filenam \
137 (-l |
--files-with-*)
138 files_with_matches
=1;;
139 (-L |
--files-witho*)
140 files_without_matches
=1;;
143 (-V |
--v |
--ve |
--ver |
--vers |
--versi |
--versio |
--version)
144 echo "$version" ||
exit 2
150 option
=\'$
(expr "X${option}X" : 'X\(.*\)' |
sed "$escape");;
155 grep="$grep $option$optarg"
158 eval "set -- $operands "'${1+"$@"}'
160 if test $have_pat -eq 0; then
161 case ${1?"missing pattern; try \`$0 --help' for help"} in
163 grep="$grep -- '"$
(printf '%sX\n' "$1" |
sed "$escape");;
165 grep="$grep -- '$1'";;
170 if test $# -eq 0; then
179 # Fail if gzip or grep (or sed) fails.
182 if test $pat_on_stdin -eq 1; then
183 eval "exec $pat_fd<&0"
185 (gzip -cdfq -- "$i" 5>&-; echo $?
>&5) 3>&- |
186 if test $files_with_matches -eq 1; then
187 eval "$grep" >/dev
/null
&& { printf '%s\n' "$i" ||
exit 2; }
188 elif test $files_without_matches -eq 1; then
189 eval "$grep" >/dev
/null ||
{
191 if test $r -eq 1; then
192 printf '%s\n' "$i" || r
=2
196 elif test $with_filename -eq 0 &&
197 { test $# -eq 1 ||
test $no_filename -eq 1; }; then
202 '* |
*'&'* |
*'\'* | *'|
'*)
203 i=$(printf '%s
\n' "$i" |
210 sed_script="s|^|$i:|"
212 # Fail if grep or sed fails.
215 (eval "$grep" 4>&-; echo $? >&4) 3>&- | sed "$sed_script" >&3 4>&-
218 test $r -gt 128 && test $r -le 143 && exit $r || exit 2
222 if test $r -gt 128 && test $r -le 143; then
226 test "$gzip_status" -eq 0 || test "$gzip_status" -eq 2 || r=2
227 test $res -lt $r && res=$r